Developer Documentation

Classes | Public Member Functions | Protected Slots | Protected Member Functions | Protected Attributes | List of all members
OVMPropertyVisualizer< MeshT > Class Template Referenceabstract
Inheritance diagram for OVMPropertyVisualizer< MeshT >:

## Classes
class | CopyProperty

## Public Member Functions
| OVMPropertyVisualizer (MeshT *_mesh, int objectID, PropertyInfo _propertyInfo)
virtual void | visualize (bool _setDrawMode, QWidget *_widget)
| Visualizes a property.
virtual void | removeProperty ()
| Should remove the property. More...
virtual void | duplicateProperty ()
| Duplicates a property.
virtual void | clear ()
| Clears a property.
virtual QString | getPropertyText (unsigned int index)=0
| Returns the value of a property in text form. More...
unsigned int | getClosestPrimitiveId (unsigned int _face, ACG::Vec3d &_hitPoint)
| Returns the ID of the closest primitive.
Public Member Functions inherited from PropertyVisualizer
| PropertyVisualizer (const PropertyInfo &_propertyInfo)
| Constructor. More...
virtual | ~PropertyVisualizer ()
| Destructor.
virtual QString | getName ()
| Returns a beautiful name. More...
virtual QWidget * | getWidget ()
| Returns the visualizer's widget. More...
const PropertyInfo & | getPropertyInfo () const
| Returns the PropertyInfo.

## Protected Slots
template<typename Type >
void | showHistogram (ACG::QtWidgets::QtHistogramWidget *histogramWidget)

## Protected Member Functions
virtual void | visualizeFaceProp (bool _setDrawMode=true)
virtual void | visualizeEdgeProp (bool _setDrawMode=true)
virtual void | visualizeHalfedgeProp (bool _setDrawMode=true)
virtual void | visualizeVertexProp (bool _setDrawMode=true)
virtual void | visualizeCellProp (bool _setDrawMode=true)
virtual void | visualizeHalffaceProp (bool _setDrawMode=true)
template<typename PropType >
void | duplicateProperty_stage1 ()
template<typename InnerType >
QString | getPropertyText_ (unsigned int index)
virtual void | setCellPropertyFromText (unsigned int index, QString text)
virtual void | setFacePropertyFromText (unsigned int index, QString text)
virtual void | setHalffacePropertyFromText (unsigned int index, QString text)
virtual void | setEdgePropertyFromText (unsigned int index, QString text)
virtual void | setHalfedgePropertyFromText (unsigned int index, QString text)
virtual void | setVertexPropertyFromText (unsigned int index, QString text)
virtual void | setPropertyFromText (unsigned int index, QString text)
| Returns the value of a property in text form. More...
virtual int | getEntityCount ()
| Returns the number of entities.
virtual QString | getHeader ()
| Returns the header for saving.
unsigned int | getClosestCellId (unsigned int _face, ACG::Vec3d &_hitPoint)
unsigned int | getClosestFaceId (unsigned int _face, ACG::Vec3d &_hitPoint)
unsigned int | getClosestHalffaceId (unsigned int _face, ACG::Vec3d &_hitPoint)
unsigned int | getClosestEdgeId (unsigned int _face, ACG::Vec3d &_hitPoint)
unsigned int | getClosestHalfedgeId (unsigned int _face, ACG::Vec3d &_hitPoint)
unsigned int | getClosestVertexId (unsigned int _face, ACG::Vec3d &_hitPoint)
Protected Member Functions inherited from PropertyVisualizer
virtual std::unique_ptr< ACG::IColorCoder > | buildColorCoder ()
template<typename PropType , typename Iterable >
void | showHistogramT (ACG::QtWidgets::QtHistogramWidget *widget, Iterable data)

## Protected Attributes
MeshT * | mesh
int | mObjectID
VolumeMeshDrawModesContainer | drawModes
Protected Attributes inherited from PropertyVisualizer
PropertyInfo | propertyInfo

## Additional Inherited Members
Signals inherited from PropertyVisualizer
void | log (Logtype _type, QString _message)
void | log (QString _message)
Static Public Member Functions inherited from PropertyVisualizer
static QString | toStr (bool b)
static QString | toStr (double d)
static QString | toStr (int i)
static QString | toStr (uint8_t i)
static QString | toStr (unsigned int i)
static QString | toStr (OpenMesh::Vec3d v)
static QString | toStr (OpenMesh::Vec2d v)
static QString | toStr (OpenMesh::Vec2f v)
static QString | toStr (const ACG::Matrix3x3d &v)
static bool | strToBool (QString str)
static double | strToDouble (QString str)
static int | strToInt (QString str)
static unsigned int | strToUInt (QString str)
static OpenMesh::Vec3d | strToVec3d (QString str)
static OpenMesh::Vec2d | strToVec2d (QString str)
static OpenMesh::Vec2f | strToVec2f (QString str)
Public Attributes inherited from PropertyVisualizer
QWidget * | widget

## Detailed Description

### template<typename MeshT>
class OVMPropertyVisualizer< MeshT >

Definition at line 61 of file OVMPropertyVisualizer.hh.

## Member Function Documentation

## ◆ getPropertyText()

template<typename MeshT>

virtual QString OVMPropertyVisualizer< MeshT >::getPropertyText | ( | unsigned int | i | ) |
| pure virtual

Returns the value of a property in text form.

Parameters

  i | The id of the entity whose property we want to know.

Returns
  The property value in text form.

Implements PropertyVisualizer.

Implemented in OVMPropertyVisualizerVector< MeshT >, OVMPropertyVisualizerVectorFieldDifference< MeshT >, OVMPropertyVisualizerBoolean< MeshT >, OVMPropertyVisualizerMatrix3x3< MeshT >, OVMPropertyVisualizerDouble< MeshT >, and OVMPropertyVisualizerInteger< MeshT, T >.

## ◆ removeProperty()

template<typename MeshT>

virtual void OVMPropertyVisualizer< MeshT >::removeProperty | ( |  | ) |
| inline virtual

Should remove the property.

Removing properties is not yet supported by OpenVolumeMesh. Therefor this method only informs the user of this fact via a log message.

Reimplemented from PropertyVisualizer.

Definition at line 82 of file OVMPropertyVisualizer.hh.

## ◆ setPropertyFromText()

template<typename MeshT >

void OVMPropertyVisualizer< MeshT >::setPropertyFromText | ( | unsigned int | index,
|  | QString | text
| ) |  |
| protected virtual

Returns the value of a property in text form.

Parameters

  index | The id of the entity whose property should be set.
  text | The value in text form.

This method sets the porperty of a given entity by transforming the text into the correct type. This is used when a property is loaded from a file.

Implements PropertyVisualizer.

Definition at line 97 of file OVMPropertyVisualizerT_impl.hh.

The documentation for this class was generated from the following files:

- Plugin-PropertyVis/OpenVolumeMesh/OVMPropertyVisualizer.hh
- Plugin-PropertyVis/OpenVolumeMesh/OVMPropertyVisualizerT_impl.hh